package org.vaadin.jeanchristophe;

import com.vaadin.flow.component.Tag;
import com.vaadin.flow.component.UI;
import com.vaadin.flow.component.dependency.CssImport;
import com.vaadin.flow.component.dependency.JavaScript;
import com.vaadin.flow.component.dependency.JsModule;
import com.vaadin.flow.component.dependency.NpmPackage;
import com.vaadin.flow.component.dependency.StyleSheet;
import com.vaadin.flow.component.html.Div;
import com.vaadin.flow.function.SerializableConsumer;

@Tag("monaco-editor")
@NpmPackage(value = "monaco-editor", version = "0.20.0")
// does not work
// @CssImport("monaco-editor/min/vs/editor/editor.main.css")
@StyleSheet("https://cdnjs.cloudflare.com/ajax/libs/monaco-editor/0.20.0/min/vs/editor/editor.main.min.css")
public class MonacoEditor extends Div {

    public MonacoEditor() {
        addClassName("vaadin-monaco");
        setId("vaadin-monaco");
        //initConnector();
    }


    private void initConnector() {
        runBeforeClientResponse(ui -> ui.getPage().executeJs(
                "window.initMonaco($0)",
                getElement()));
    }

    private void runBeforeClientResponse(SerializableConsumer<UI> command) {
        getElement().getNode().runWhenAttached(ui -> ui
                .beforeClientResponse(this, context -> command.accept(ui)));
    }
}
