/**
 * This file has been autogenerated as it didn't exist or was made for an older incompatible version.
 * This file can be used for manual configuration will not be modified if the flowDefaults constant exists.
 */
const merge = require('webpack-merge');
const flowDefaults = require('./webpack.generated.js');
const MonacoWebpackPlugin = require('monaco-editor-webpack-plugin');

const path = require('path');

module.exports = merge(flowDefaults, {
    mode: process.env.NODE_ENV,
    entry: './src/monaco-connector.js',
    output: {
        path: path.resolve(__dirname, 'dist'),
        filename: '[name].bundle.js'
    },
    module: {
        rules: [{
            test: /\.css$/,
            use: ['style-loader', 'css-loader']
        }, {
            test: /\.ttf$/,
            use: ['file-loader']
        }]
    },
    plugins: [
        new MonacoWebpackPlugin({
            languages: ["typescript", "javascript", "css"],
        })
    ]
});

//
//
// const MonacoWebpackPlugin = require('monaco-editor-webpack-plugin');
// const path = require('path');
//
// module.exports = merge(flowDefaults, {
//     entry: './src/monaco-connector.js',
//     output: {
//         path: path.resolve(__dirname, 'dist'),
//         filename: '[name]-worker.js'
//     },
//     module: {
//         rules: [{
//             test: /\.css$/,
//             use: ['style-loader', 'css-loader']
//         }, {
//             test: /\.ttf$/,
//             use: ['file-loader']
//         }]
//     },
//     plugins: [
//         new MonacoWebpackPlugin()
//     ]
// });

/**
 * This file can be used to configure the flow plugin defaults.
 * <code>
 *   // Add a custom plugin
 *   flowDefaults.plugins.push(new MyPlugin());
 *
 *   // Update the rules to also transpile `.mjs` files
 *   if (!flowDefaults.module.rules[0].test) {
 *     throw "Unexpected structure in generated webpack config";
 *   }
 *   flowDefaults.module.rules[0].test = /\.m?js$/
 *
 *   // Include a custom JS in the entry point in addition to generated-flow-imports.js
 *   if (typeof flowDefaults.entry.index != "string") {
 *     throw "Unexpected structure in generated webpack config";
 *   }
 *   flowDefaults.entry.index = [flowDefaults.entry.index, "myCustomFile.js"];
 * </code>
 * or add new configuration in the merge block.
 * <code>
 *   module.exports = merge(flowDefaults, {
 *     mode: 'development',
 *     devtool: 'inline-source-map'
 *   });
 * </code>
 */
